unit Explor;

interface

uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,
     ComCtrls,TypInfo,Menus,Clipbrd, ToolWin, ExtCtrls,ActnList;

type
TBExplorer = class(TForm)
 TreeView1: TTreeView;
 PopupMenu1: TPopupMenu;
 SavetoFileBExplortxt1:TMenuItem;
 SelectedtoClipboard1:TMenuItem;
 Splitter1: TSplitter;
 TreeView2: TTreeView;
 ViewObjectbyAddress1: TMenuItem;
 ViewMemorybyAddress: TMenuItem;
 BrowseObjectbyAddress1: TMenuItem;
    Hidesecondtree1: TMenuItem;
 procedure FormDestroy(Sender: TObject);
 procedure FormCreate(Sender: TObject);
 procedure TreeView1Deletion(Sender:TObject;Node:TTreeNode);
 procedure TreeView1Expanding(Sender:TObject;Node:TTreeNode;var AllowExpansion:Boolean);
 procedure TreeView1Collapsed(Sender:TObject;Node:TTreeNode);
 procedure SavetoFileBExplortxt1Click(Sender:TObject);
 procedure SelectedtoClipboard1Click(Sender:TObject);
 procedure ViewObjectbyAddress1Click(Sender: TObject);
 procedure ViewMemorybyAddressClick(Sender: TObject);
 procedure BrowseObjectbyAddress1Click(Sender: TObject);
    procedure Hidesecondtree1Click(Sender: TObject);
public
 procedure CreateNodes(tn:TTreeNode);
end;

TBNodeData=class
public
 data:pointer;
 ti:PTypeInfo;
 pi:PPropInfo;
 special:integer;
 constructor Create(adata:pointer; ati:PTypeInfo); overload;
 constructor Create(adata:pointer; ati:PTypeInfo; api:PPropInfo); overload;
 constructor Create(adata:pointer; ati:PTypeInfo; api:PPropInfo; aspecial:integer); overload;
end;

var
  BExplorer: TBExplorer;

implementation

{$R *.DFM}

procedure TBExplorer.FormDestroy(Sender: TObject);
begin
 BExplorer:=nil;
end;

procedure TBExplorer.CreateNodes(tn:TTreeNode);
var nd:TBNodeData;
    td:PTypeData; pl:PPropList;
    ti:PTypeInfo; ct:TClass;
    i,j:integer; s:string; l:longint; e:extended; m:TMethod; o:TObject; p,p2:pointer;
    i64:Int64;

function Decode(p:pointer):string;
var x:array[0..3] of byte absolute p;
    l:longint absolute p;
begin
 if x[3]=$FF then result:='Field='+IntToStr(l and $FFFFFF) else
  if x[3]=$FE then result:='Virtual='+IntToStr(l and $FFFF) else
   result:='Static';
end;

type PShortInt=^ShortInt; PComp=^Comp; PMethod=^TMethod; PPointer=^Pointer;
     PFieldClassTable=^TFieldClassTable;
     TFieldClassTable=packed record
      Count:Smallint;
      Classes:array[0..8191] of ^TPersistentClass;
     end;
     TAByte=array[0..999999] of byte;
     PAByte=^TAByte;
begin
 tn.DeleteChildren;
 if tn.Text='Delphi IDE' then begin
  tn.Owner.AddChildObject(tn,'Application',TBNodeData.Create(Application,Application.classinfo));
  tn.Owner.AddChildObject(tn,'Screen',TBNodeData.Create(Screen,Screen.classinfo));
  tn.Owner.AddChildObject(tn,'Application.MainForm',TBNodeData.Create(Application.MainForm,Application.MainForm.classinfo));
  exit;
 end;
 nd:=TBNodeData(tn.data);
 if nd=nil then exit;
 ti:=nd.ti;
 if ti=nil then begin
  if nd.pi=nil then begin
   if nd.data<>nil then begin
    if nd.special=2 then begin
     tn.Owner.AddChild(tn,'ClassName:'+TObject(nd.data).ClassName+' InstanceSize:'+IntToStr(TObject(nd.data).InstanceSize));
     p:=TObject(nd.data).ClassType.ClassParent;
     s:='ClassParents:';
     while Assigned(p) do begin
      s:=s+' '+TClass(p).ClassName;
      p:=TClass(p).ClassParent;
     end;
     tn.Owner.AddChild(tn,s);
     p:=ppointer(longint(pointer(TObject(nd.data).ClassType))+vmtFieldTable)^;
     if Assigned(p) then begin
      tn.Owner.AddChild(tn,'FieldTable ('+IntToStr(PWord(p)^)+')');
     end;
     p:=ppointer(longint(pointer(TObject(nd.data).ClassType))+vmtMethodTable)^;
     if Assigned(p) then begin
      tn.Owner.AddChild(tn,'MethodTable ('+IntToStr(PWord(p)^)+')');
     end;
     for i:=0 to (TObject(nd.data).InstanceSize) div 4-1 do begin
      s:=IntToHex(i*4,4)+': ';
      for j:=0 to 3 do s:=s+IntToHex(PAByte(nd.data)^[j+i*4],2)+' ';
      for j:=0 to 3 do if PAByte(nd.data)^[j+i*4]>=32 then s:=s+chr(PAByte(nd.data)^[j+i*4]) else s:=s+'.';
      try
       p:=PPointer(@(PAByte(nd.data)^[i*4]))^;
       if (Assigned(p)) and (PAByte(nd.data)^[3+i*4]=1) then begin
        p2:=TObject(p).ClassType;
        if (longint(p2)>100) and (longint(p2)<$1000000) and (ppointer(longint(p2)+vmtSelfPtr)^=p2) then begin
         tn.Owner.AddChildObject(tn,s+' Object at '+IntToHex(integer(p),8),TBNodeData.Create(p,nil,nil,2));
        end else begin
         tn.Owner.AddChildObject(tn,s+' Memory at '+IntToHex(integer(p),8),TBNodeData.Create(p,nil));
        end;
       end else begin
        tn.Owner.AddChild(tn,s);
       end;
      except
       tn.Owner.AddChild(tn,s);
      end;
     end;
    end else if nd.special=1 then begin
     tn.Owner.AddChild(tn,'ClassName:'+TObject(nd.data).ClassName+' InstanceSize:'+IntToStr(TObject(nd.data).InstanceSize));
     p:=TObject(nd.data).ClassType.ClassParent;
     s:='ClassParents:';
     while Assigned(p) do begin
      s:=s+' '+TClass(p).ClassName;
      p:=TClass(p).ClassParent;
     end;
     tn.Owner.AddChild(tn,s);
     p:=ppointer(longint(pointer(TObject(nd.data).ClassType))+vmtFieldTable)^;
     if Assigned(p) then begin
      tn.Owner.AddChild(tn,'FieldTable ('+IntToStr(PWord(p)^)+')');
     end;
     p:=ppointer(longint(pointer(TObject(nd.data).ClassType))+vmtMethodTable)^;
     if Assigned(p) then begin
      tn.Owner.AddChild(tn,'MethodTable ('+IntToStr(PWord(p)^)+')');
     end;
     for i:=0 to (TObject(nd.data).InstanceSize+15) div 16-1 do begin
      s:=IntToHex(i*16,2)+': ';
      for j:=0 to 15 do s:=s+IntToHex(PAByte(nd.data)^[j+i*16],2)+' ';
      for j:=0 to 15 do if PAByte(nd.data)^[j+i*16]>=32 then s:=s+chr(PAByte(nd.data)^[j+i*16]) else s:=s+'.';
      tn.Owner.AddChild(tn,s);
     end;
    end else begin
     for i:=0 to 15 do begin
      s:=IntToHex(i*16,2)+': ';
      for j:=0 to 15 do s:=s+IntToHex(PAByte(nd.data)^[j+i*16],2)+' ';
      for j:=0 to 15 do if PAByte(nd.data)^[j+i*16]>=32 then s:=s+chr(PAByte(nd.data)^[j+i*16]) else s:=s+'.';
      tn.Owner.AddChild(tn,s);
     end;
    end;
   end else begin
    tn.Owner.AddChild(tn,'NIL');
   end;
   exit;
  end else begin
   ti:=nd.pi^.PropType^;
  end;
 end;
 if (nd.pi<>nil) and (nd.special=0) then begin
  s:='Get: '+Decode(nd.pi^.GetProc)+' Set: '+Decode(nd.pi^.SetProc)
   +' Stored: '+IntToStr(ord(IsStoredProp(nd.Data,nd.pi)));
  if LongWord(nd.pi^.Default)<>$80000000 then s:=s+' Def: '+IntToStr(nd.pi^.Default);
  if LongWord(nd.pi^.Index)<>$80000000 then s:=s+' Index: '+IntToStr(nd.pi^.Index);
  tn.Owner.AddChild(tn,s);
 end;
 if nd.Special=0 then tn.Owner.AddChild(tn,'Type: '+ti^.Name);
 case ti^.Kind of
  tkUnknown:begin
   tn.Owner.AddChild(tn,'Kind: Unknown');
  end;
  tkInteger:begin
   tn.Owner.AddChild(tn,'Kind: Integer');
   if nd.pi<>nil then begin
    l:=GetOrdProp(nd.data,nd.pi);
   end else begin
    td:=GetTypeData(ti);
    case td.OrdType of
     otSByte:l:=PShortInt(nd.data)^;
     otUByte:l:=PByte(nd.data)^;
     otSWord:l:=PSmallInt(nd.data)^;
     otUWord:l:=PWord(nd.data)^;
     otSLong:l:=PLongint(nd.data)^;
     else l:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+IntToStr(l)+' ('+IntToHex(l,8)+')');
  end;
  tkChar:begin
   tn.Owner.AddChild(tn,'Kind: Char');
   if nd.pi<>nil then begin
    l:=GetOrdProp(nd.data,nd.pi);
   end else begin
    td:=GetTypeData(ti);
    case td.OrdType of
     otSByte:l:=PShortInt(nd.data)^;
     otUByte:l:=PByte(nd.data)^;
     otSWord:l:=PSmallInt(nd.data)^;
     otUWord:l:=PWord(nd.data)^;
     otSLong:l:=PLongint(nd.data)^;
     else l:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+IntToStr(l)+' ('+IntToHex(l,8)+')');
  end;
  tkEnumeration:begin
   tn.Owner.AddChild(tn,'Kind: Enumeration');
   td:=GetTypeData(ti);
   if nd.pi<>nil then begin
    l:=GetOrdProp(nd.data,nd.pi);
   end else begin
    case td.OrdType of
     otSByte:l:=PShortInt(nd.data)^;
     otUByte:l:=PByte(nd.data)^;
     otSWord:l:=PSmallInt(nd.data)^;
     otUWord:l:=PWord(nd.data)^;
     otSLong:l:=PLongint(nd.data)^;
     else l:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+GetEnumName(ti,l)+' ('+IntToStr(l)+'='+IntToHex(l,8)+')');
   if (td.BaseType<>nil) and (td.BaseType^<>nil) and (td.BaseType^^.Kind=tkEnumeration) then begin
    for i:=0 to GetTypeData(td.BaseType^)^.MaxValue-GetTypeData(td.BaseType^)^.MinValue do begin
     s:=GetEnumName(td.BaseType^,GetTypeData(td.BaseType^)^.MinValue+i);
     tn.Owner.AddChild(tn,'Enums: '+IntToStr(i)+' '+s);
    end;
   end;
  end;
  tkFloat:begin
   tn.Owner.AddChild(tn,'Kind: Float');
   if nd.pi<>nil then begin
    e:=GetFloatProp(nd.data,nd.pi);
   end else begin
    td:=GetTypeData(ti);
    case td.FloatType of
     ftSingle:e:=PSingle(nd.data)^;
     ftDouble:e:=PDouble(nd.data)^;
     ftExtended:e:=PExtended(nd.data)^;
     ftComp:e:=PComp(nd.data)^;
     ftCurr:e:=PCurrency(nd.data)^;
     else e:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+FloatToStr(e));
  end;
  tkString:begin
   tn.Owner.AddChild(tn,'Kind: String');
   td:=GetTypeData(ti);
   if nd.pi<>nil then begin
    s:=GetStrProp(nd.data,nd.pi);
   end else begin
    s:=PShortString(nd.data)^;
   end;
   tn.Owner.AddChild(tn,'Value: '+s);
   tn.Owner.AddChild(tn,'MaxSize: '+IntToStr(td.MaxLength));
  end;
  tkSet:begin
   tn.Owner.AddChild(tn,'Kind: Set');
   td:=GetTypeData(ti);
   if nd.pi<>nil then begin
    l:=GetOrdProp(nd.data,nd.pi);
   end else begin
    case td.OrdType of
     otSByte:l:=PShortInt(nd.data)^;
     otUByte:l:=PByte(nd.data)^;
     otSWord:l:=PSmallInt(nd.data)^;
     otUWord:l:=PWord(nd.data)^;
     otSLong:l:=PLongint(nd.data)^;
     else l:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+IntToStr(l)+' ('+IntToHex(l,8)+')');
   if (td.CompType<>nil) and (td.CompType^<>nil) and (td.CompType^^.Kind=tkEnumeration) then begin
    for i:=0 to GetTypeData(td.CompType^)^.MaxValue-GetTypeData(td.CompType^)^.MinValue do begin
     s:=GetEnumName(td.CompType^,GetTypeData(td.CompType^)^.MinValue+i);
     if ((1 shl i) and l)>0 then begin
      tn.Owner.AddChild(tn,'In Set: '+IntToStr(i)+' '+s);
     end else begin
      tn.Owner.AddChild(tn,'Not In Set: '+IntToStr(i)+' '+s);
     end;
    end;
   end else begin
    for i:=0 to 31 do if ((1 shl i) and l)>0 then tn.Owner.AddChild(tn,'InSet: '+IntToStr(i));
   end;
  end;
  tkClass:begin
   td:=GetTypeData(ti);
   if nd.pi<>nil then begin
    o:=TObject(Pointer(GetOrdProp(nd.data,nd.pi)));
   end else begin
    o:=TObject(nd.data);
   end;
   if nd.special=0 then begin
    tn.Owner.AddChild(tn,'Kind: Class  Address: '+IntToStr(LongWord(o))+' '+IntToHex(LongWord(o),8));
    tn.Owner.AddChild(tn,'ClassName: '+td^.ClassType.ClassName+' InstanceSize: '+IntToStr(td^.ClassType.InstanceSize)+' UnitName: '+td^.UnitName);
    s:='ClassParents: ';
    ct:=td^.ClassType;
    while ct.ClassParent<>nil do begin
     ct:=ct.ClassParent;
     s:=s+ct.ClassName+' ';
    end;
    if s<>'' then tn.Owner.AddChild(tn,copy(s,1,length(s)-1));
    if Assigned(o) then begin
     tn.Owner.AddChildObject(tn,'Properties ('+IntToStr(td^.PropCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,1));
    end else begin
     tn.Owner.AddChild(tn,'Value: None (nil)');
    end;
    p:=ppointer(longint(pointer(td^.ClassType))+vmtFieldTable)^;
    if Assigned(p) then begin
     tn.Owner.AddChildObject(tn,'FieldTable ('+IntToStr(PWord(p)^)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,3));
    end;
    p:=ppointer(longint(pointer(td^.ClassType))+vmtMethodTable)^;
    if Assigned(p) then begin
     tn.Owner.AddChildObject(tn,'MethodTable ('+IntToStr(PWord(p)^)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,4));
    end;
   end;
   if nd.special=3 then begin
    p:=pointer(pointer(longint(pointer(td^.ClassType))+vmtFieldTable)^);
    l:=PWord(p)^;
    inc(longint(p),2);
    p2:=Pointer(Pointer(p)^);
    inc(longint(p),4);
    for i:=0 to l-1 do begin
     inc(longint(p),6);
     j:=PWord(longint(p)-2)^;
     if Assigned(o) and Assigned(o.FieldAddress(PShortString(p)^)) and
     (PFieldClassTable(p2)^.Count>j) and Assigned(PFieldClassTable(p2)^.Classes[j])
     and (PFieldClassTable(p2)^.Classes[j]^.ClassInfo<>nil) then begin
      tn.Owner.AddChildObject(tn,IntToStr(i)+': '+PShortString(p)^
       ,TBNodeData.Create(Pointer(o.FieldAddress(PShortString(p)^)^),
       PFieldClassTable(p2)^.Classes[j]^.ClassInfo));
     end else begin
      tn.Owner.AddChild(tn,IntToStr(i)+': '+PShortString(p)^);
     end;
     inc(longint(p),length(PShortString(p)^)+1);
    end;
   end;
   if nd.special=4 then begin
    p:=pointer(pointer(longint(pointer(td^.ClassType))+vmtMethodTable)^);
    l:=PWord(p)^;
    inc(longint(p),2);
    for i:=0 to l-1 do begin
     tn.Owner.AddChild(tn,IntToStr(i)+': '+PShortString(longint(p)+6)^+' (LenInfo:'+IntToStr(PWord(p)^-7-PByte(longint(p)+6)^)+')');
     inc(longint(p),PWord(p)^);
    end;
   end;
   if nd.special=1 then begin
    GetMem(pl,td^.PropCount*4);
    GetPropInfos(ti,pl);
    for i:=0 to td^.PropCount-1 do begin
     if nd.pi<>nil then begin
      tn.Owner.AddChildObject(tn,IntToStr(i+1)+': '+pl^[i]^.Name,TBNodeData.Create(Pointer(GetOrdProp(nd.data,nd.pi)),nil,pl^[i]));
     end else begin
      tn.Owner.AddChildObject(tn,IntToStr(i+1)+': '+pl^[i]^.Name,TBNodeData.Create(nd.data,nil,pl^[i]));
     end;
    end;
    FreeMem(pl);
   end;
   ct:=td^.ClassType;
   if ct.InheritsFrom(TComponent) then begin
    if o<>nil then begin
     if nd.special=0 then begin
      if TComponent(o).Owner=nil then tn.Owner.AddChild(tn,'ComponentOwner: None (nil)') else
       tn.Owner.AddChild(tn,'ComponentOwner: Name: '+TComponent(o).Owner.Name
        +' Class: '+TComponent(o).Owner.ClassName);
      tn.Owner.AddChildObject(tn,'Components ('+IntToStr(TComponent(o).ComponentCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,2));
     end;
     if nd.special=2 then begin
      for i:=0 to TComponent(o).ComponentCount-1 do begin
       tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TComponent(o).Components[i].Name
        ,TBNodeData.Create(TComponent(o).Components[i],TComponent(o).Components[i].classinfo));
      end;
     end;
    end;
   end;
   if ct.InheritsFrom(TWinControl) then begin
    if o<>nil then begin
     if nd.special=0 then begin
      if TControl(o).Parent=nil then tn.Owner.AddChild(tn,'ControlParent: None (nil)') else
       tn.Owner.AddChild(tn,'ControlParent: Name: '+TControl(o).Parent.Name
        +' Class: '+TControl(o).Parent.ClassName);
      tn.Owner.AddChildObject(tn,'Controls ('+IntToStr(TWinControl(o).ControlCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,20));
     end;
     if nd.special=20 then begin
      for i:=0 to TWinControl(o).ControlCount-1 do begin
       tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TWinControl(o).Controls[i].Name
        ,TBNodeData.Create(TWinControl(o).Controls[i],TWinControl(o).Controls[i].ClassInfo));
      end;
     end;
    end;
   end;
   if ct.InheritsFrom(TCustomActionList) then begin
    if o<>nil then begin
     if nd.special=0 then begin
      tn.Owner.AddChildObject(tn,'Actions ('+IntToStr(TCustomActionList(o).ActionCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,21));
     end;
     if nd.special=21 then begin
      for i:=0 to TCustomActionList(o).ActionCount-1 do begin
       tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TCustomActionList(o).Actions[i].Name
        ,TBNodeData.Create(TCustomActionList(o).Actions[i],TCustomActionList(o).Actions[i].ClassInfo));
      end;
     end;
    end;
   end;
   if ct.InheritsFrom(TMenuItem) then begin
    if o<>nil then begin
     if nd.special=0 then begin
      tn.Owner.AddChildObject(tn,'Items ('+IntToStr(TMenuItem(o).Count)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,22));
     end;
     if nd.special=22 then begin
      for i:=0 to TMenuItem(o).Count-1 do begin
       tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TMenuItem(o).Items[i].Name+' Caption:'+TMenuItem(o).Items[i].Caption
        ,TBNodeData.Create(TMenuItem(o).Items[i],TMenuItem(o).Items[i].ClassInfo));
      end;
     end;
    end;
   end;
   if Assigned(o) and (o is TStrings) then begin
    if nd.special=0 then begin
     tn.Owner.AddChildObject(tn,'Strings and Objects ('+IntToStr(TStrings(o).Count)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,2));
    end;
    if nd.special=2 then begin
     for i:=0 to TStrings(o).Count-1 do begin
      if Assigned(TStrings(o).Objects[i]) then begin
       s:='? Object is not class ?';
       p2:=nil;
       try
        p:=PPointer(TStrings(o).Objects[i])^;
        if Assigned(p) then begin
         s:=PShortString(PPointer(longint(p)+vmtClassName)^)^;
         while (p2=nil) and (p<>nil) do begin
          if Assigned(PPointer(longint(p)+vmtTypeInfo)^) then begin
           p2:=PPointer(longint(p)+vmtTypeInfo)^; break;
          end;
          p:=PPointer(longint(p)+vmtParent)^;
          if Assigned(p) then p:=PPointer(p)^;
         end;
        end;
       except
       end;
       for j:=1 to length(s) do if s[j]<#32 then s[j]:='?';
       if p2=nil then begin
        tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TStrings(o)[i]+' '+IntToStr(longint(TStrings(o).Objects[i]))+' '+IntToHex(longint(TStrings(o).Objects[i]),8)+' '+s
         ,TBNodeData.Create(TStrings(o).Objects[i],nil,nil,1));
       end else begin
        tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TStrings(o)[i]+' '+IntToStr(longint(TStrings(o).Objects[i]))+' '+IntToHex(longint(TStrings(o).Objects[i]),8)+' '+s
         ,TBNodeData.Create(TStrings(o).Objects[i],p2));
       end;
      end else begin
       tn.Owner.AddChild(tn,IntToStr(i)+': '+TStrings(o)[i]);
      end;
     end;
    end;
   end;
   if Assigned(o) and (o is TScreen) then begin
    if nd.special=0 then begin
     tn.Owner.AddChildObject(tn,'Forms ('+IntToStr(TScreen(o).FormCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,10));
     tn.Owner.AddChildObject(tn,'CustomForms ('+IntToStr(TScreen(o).CustomFormCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,11));
     tn.Owner.AddChildObject(tn,'DataModules ('+IntToStr(TScreen(o).DataModuleCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,12));
     tn.Owner.AddChildObject(tn,'Monitors ('+IntToStr(TScreen(o).MonitorCount)+')',TBNodeData.Create(nd.data,nd.ti,nd.pi,13));
    end;
    if nd.special=10 then begin
     for i:=0 to TScreen(o).FormCount-1 do begin
      tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TScreen(o).Forms[i].Name
       ,TBNodeData.Create(TScreen(o).Forms[i],TScreen(o).Forms[i].classinfo));
     end;
    end;
    if nd.special=11 then begin
     for i:=0 to TScreen(o).CustomFormCount-1 do begin
      tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TScreen(o).CustomForms[i].Name
       ,TBNodeData.Create(TScreen(o).CustomForms[i],TScreen(o).CustomForms[i].classinfo));
     end;
    end;
    if nd.special=12 then begin
     for i:=0 to TScreen(o).DataModuleCount-1 do begin
      tn.Owner.AddChildObject(tn,IntToStr(i)+': '+TScreen(o).DataModules[i].Name
       ,TBNodeData.Create(TScreen(o).DataModules[i],TScreen(o).DataModules[i].classinfo));
     end;
    end;
    if nd.special=13 then begin
     for i:=0 to TScreen(o).MonitorCount-1 do begin
      with TScreen(o).Monitors[i] do tn.Owner.AddChildObject(tn,Format('%d: Handle:%d Left:%d Top:%d Width:%d Height:%d',[i,Handle,Left,Top,Width,Height]),nil);
     end;
    end;
   end;
  end;
  tkMethod:begin
   tn.Owner.AddChild(tn,'Kind: Method');
   if nd.pi<>nil then begin
    m:=GetMethodProp(nd.data,nd.pi);
   end else begin
    m:=PMethod(nd.data)^;
   end;
   if Assigned(m.Code) and Assigned(m.Data) then begin
    tn.Owner.AddChildObject(tn,'Value: '+TObject(m.Data).MethodName(m.Code),TBNodeData.Create(m.Data,TObject(m.Data).ClassInfo));
   end else begin
    tn.Owner.AddChild(tn,'Value: None (nil)');
   end;
  end;
  tkWChar:begin
   tn.Owner.AddChild(tn,'Kind: WChar');
   if nd.pi<>nil then begin
    l:=GetOrdProp(nd.data,nd.pi);
   end else begin
    td:=GetTypeData(ti);
    case td.OrdType of
     otSByte:l:=PShortInt(nd.data)^;
     otUByte:l:=PByte(nd.data)^;
     otSWord:l:=PSmallInt(nd.data)^;
     otUWord:l:=PWord(nd.data)^;
     otSLong:l:=PLongint(nd.data)^;
     else l:=0;
    end;
   end;
   tn.Owner.AddChild(tn,'Value: '+IntToStr(l)+' ('+IntToHex(l,8)+')');
  end;
  tkLString:begin
   tn.Owner.AddChild(tn,'Kind: LString');
   if nd.pi<>nil then begin
    s:=GetStrProp(nd.data,nd.pi);
   end else begin
    s:=PString(nd.data)^;
   end;
   tn.Owner.AddChild(tn,'Value: '+s);
  end;
  tkWString:begin
   tn.Owner.AddChild(tn,'Kind: WString');
   if nd.pi<>nil then begin
    s:=GetStrProp(nd.data,nd.pi);
   end else begin
    s:=PWideString(nd.data)^;
   end;
   tn.Owner.AddChild(tn,'Value: '+s);
  end;
  tkVariant:begin
   tn.Owner.AddChild(tn,'Kind: Variant');
   if nd.pi<>nil then begin
    s:=GetVariantProp(nd.data,nd.pi);
    tn.Owner.AddChild(tn,'Value: '+s);
   end;
  end;
  tkArray:begin
   tn.Owner.AddChild(tn,'Kind: Array');
  end;
  tkRecord:begin
   tn.Owner.AddChild(tn,'Kind: Record');
  end;
  tkInterface:begin
   tn.Owner.AddChild(tn,'Kind: Interface');
  end;
  tkInt64:begin
   tn.Owner.AddChild(tn,'Kind: Int64');
   if nd.pi<>nil then begin
    i64:=GetInt64Prop(nd.data,nd.pi);
    tn.Owner.AddChild(tn,'Value: '+IntToStr(i64));
   end;
   td:=GetTypeData(ti);
   tn.Owner.AddChild(tn,'MinValue: '+IntToStr(td.MinInt64Value)+' MaxValue: '+IntToStr(td.MaxInt64Value));
  end;
  tkDynArray:begin
   tn.Owner.AddChild(tn,'Kind: DynArray');
  end;
  else begin
   tn.Owner.AddChild(tn,'Kind: Wrong '+IntToStr(ord(nd.ti^.Kind)));
  end;
 end;
end;

procedure TBExplorer.FormCreate(Sender: TObject);
var tn:TTreeNode;
begin
 TreeView1.Items.Clear;
 tn:=TreeView1.Items.AddChildObjectFirst(nil,'Delphi IDE',TBNodeData.Create(nil,nil));
 CreateNodes(tn);
end;

constructor TBNodeData.Create(adata:pointer; ati:PTypeInfo);
begin
 data:=adata; ti:=ati; pi:=nil; special:=0;
end;

constructor TBNodeData.Create(adata:pointer; ati:PTypeInfo; api:PPropInfo);
begin
 data:=adata; ti:=ati; pi:=api; special:=0;
end;

constructor TBNodeData.Create(adata:pointer; ati:PTypeInfo; api:PPropInfo; aspecial:integer);
begin
 data:=adata; ti:=ati; pi:=api; special:=aspecial;
end;

procedure TBExplorer.TreeView1Deletion(Sender: TObject; Node: TTreeNode);
begin
 TBNodeData(Node.Data).Free;
end;

procedure TBExplorer.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var i:integer;
begin
 AllowExpansion:=true;
 Screen.Cursor:=crHourGlass;
 for i:=0 to Node.Count-1 do begin
  try
   CreateNodes(Node.Item[i]);
  except
   on Exception do begin
    Node.Item[i].Owner.AddChild(Node.Item[i],'Exception: '+Exception(ExceptObject).Message);
   end;
  end;
 end;
 Screen.Cursor:=crDefault;
end;

procedure TBExplorer.TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
var i:integer;
begin
 Screen.Cursor:=crHourGlass;
 for i:=0 to Node.Count-1 do Node.Item[i].DeleteChildren;
 Screen.Cursor:=crDefault;
end;

procedure TBExplorer.SavetoFileBExplortxt1Click(Sender: TObject);
begin
 Screen.Cursor:=crHourGlass;
 TreeView1.SaveToFile('BExplor.txt');
 Screen.Cursor:=crDefault;
end;

procedure TBExplorer.SelectedtoClipboard1Click(Sender: TObject);
begin
 ClipBoard.AsText:=TreeView1.Selected.Text;
end;

procedure TBExplorer.ViewObjectbyAddress1Click(Sender: TObject);
var s:string; i:integer;
    o:TObject;
    tn:TTreeNode;
begin
 s:=InputBox('View Object','Hex Address','');
 if s<>'' then begin
  o:=nil;
  s:=UpperCase(s);
  for i:=1 to length(s) do begin
   integer(o):=integer(o)*16;
   if s[i] in ['0'..'9'] then inc(integer(o),ord(s[i])-ord('0'));
   if s[i] in ['A'..'F'] then inc(integer(o),ord(s[i])-ord('A')+10);
  end;
  TreeView2.Items.Clear;
  if o.ClassInfo=nil then begin
   tn:=TreeView2.Items.AddChildObjectFirst(nil,'User object at '+IntToHex(integer(o),8),TBNodeData.Create(o,nil,nil,1));
  end else begin
   tn:=TreeView2.Items.AddChildObjectFirst(nil,'User object at '+IntToHex(integer(o),8),TBNodeData.Create(o,o.ClassInfo));
  end;
  CreateNodes(tn);
  TreeView1.Align:=alTop;
  TreeView1.Height:=ClientHeight div 2;
  Splitter1.Visible:=true;
  Splitter1.Top:=TreeView1.Height;
  TreeView2.Visible:=true;
  If TreeView2.Height=0 then TreeView2.Height:=30;
 end;
end;

procedure TBExplorer.ViewMemorybyAddressClick(Sender: TObject);
var s:string; i:integer;
    o:TObject;
    tn:TTreeNode;
begin
 s:=InputBox('View Memory','Hex Address','');
 if s<>'' then begin
  o:=nil;
  s:=UpperCase(s);
  for i:=1 to length(s) do begin
   integer(o):=integer(o)*16;
   if s[i] in ['0'..'9'] then inc(integer(o),ord(s[i])-ord('0'));
   if s[i] in ['A'..'F'] then inc(integer(o),ord(s[i])-ord('A')+10);
  end;
  TreeView2.Items.Clear;
  tn:=TreeView2.Items.AddChildObjectFirst(nil,'Memory at '+IntToHex(integer(o),8),TBNodeData.Create(o,nil));
  CreateNodes(tn);
  TreeView1.Align:=alTop;
  TreeView1.Height:=ClientHeight div 2;
  Splitter1.Visible:=true;
  Splitter1.Top:=TreeView1.Height;
  TreeView2.Visible:=true;
  If TreeView2.Height=0 then TreeView2.Height:=30;
 end;
end;

procedure TBExplorer.BrowseObjectbyAddress1Click(Sender: TObject);
var s:string; i:integer;
    o:TObject;
    tn:TTreeNode;
begin
 s:=InputBox('Browse Object','Hex Address','');
 if s<>'' then begin
  o:=nil;
  s:=UpperCase(s);
  for i:=1 to length(s) do begin
   integer(o):=integer(o)*16;
   if s[i] in ['0'..'9'] then inc(integer(o),ord(s[i])-ord('0'));
   if s[i] in ['A'..'F'] then inc(integer(o),ord(s[i])-ord('A')+10);
  end;
  TreeView2.Items.Clear;
  tn:=TreeView2.Items.AddChildObjectFirst(nil,'User object at '+IntToHex(integer(o),8),TBNodeData.Create(o,nil,nil,2));
  CreateNodes(tn);
  TreeView1.Align:=alTop;
  TreeView1.Height:=ClientHeight div 2;
  Splitter1.Visible:=true;
  Splitter1.Top:=TreeView1.Height;
  TreeView2.Visible:=true;
  If TreeView2.Height=0 then TreeView2.Height:=30;
 end;
end;

procedure TBExplorer.Hidesecondtree1Click(Sender: TObject);
begin
 TreeView1.Align:=alClient;
 Splitter1.Visible:=false;
 TreeView2.Visible:=false;
end;

end.

